<Cabbage> bounds(0, 0, 0, 0)
form caption("WaveTable - Andrei Valentino") size(800, 600), colour(150, 30, 220), pluginid("def1")
keyboard bounds(0, 504, 800, 95){
combobox bounds(0, 12, 395, 22) channel("OWF") text("Sine", "Sawtooth 5x", "square 5x", "Ep1_da_furia", " Ep1_Gen9" , "EP2_DaFuria", "vib_Dafuria", "Timpani_Dafuria", "TingShaw_sethares", "ChacoRock_Sethares", "BellTone_Sethares" ,"SawAsc" , " SawDsc" , "Tri_1", "Tri_2", " Square_Line", "Pulse_25" )}
label bounds(0, -2, 80, 16) channel("WaveForm") identchannel("WaveForm") text("WaveForm") fontcolour(0, 0, 0, 160)
}
groupbox bounds(529, 52, 241, 122) identchannel("Master - Valentino") text("Master "){
rslider bounds(-20, 29, 168, 80) range(0, 1, 0.532, 1, 0) channel("masterPan") text("Panorámica") valuetextbox(1)
rslider bounds(106, 29, 168, 80) range(0, 1, 0.8, 1, 0) channel("masterV") text("Master") valuetextbox(1) trackercolour(10, 132, 10, 255)
}
groupbox bounds(13, 52, 229, 123) identchannel("Tuner") text("Tuner") fontcolour(147, 128, 128, 255) outlinecolour(137, 125, 125, 255)
rslider bounds(20, 84, 71, 76) range(-1, 1, 0, 1, 0.0001) channel("FINE")   valuetextbox(1) text("Fine")
rslider bounds(92, 84, 72, 77) range(-12, 12, 0, 1, 1) channel("COARSE")   valuetextbox(1) text("Coarse")
rslider bounds(164, 84, 69, 77) range(-2, 3, 0, 1, 1) channel("RANGE")   valuetextbox(1) text("Range")
}
groupbox bounds(529, 218, 240, 114) identchannel("AEG") text("AEG") colour(29, 34, 34, 255){
vslider bounds(10, 19, 47, 84) range(0.001, 5, 0.001, 1, 0.001) channel("A1")  text("A") valuetextbox(1)
vslider bounds(50, 19, 50, 84) range(0.001, 5, 0.001, 1, 0.001) channel("D1") value(0.001) text("D") valuetextbox(1)
vslider bounds(101, 19, 50, 84) range(0, 1, 0.8, 1, 0.01) channel("S1")  text("S") valuetextbox(1) 
vslider bounds(152, 19, 47, 84) range(0.001, 5, 0.001, 1, 0.001) channel("R1")  text("R") valuetextbox(1)
button bounds(203, 24, 35, 19) channel("SwEG1") text("Off", "On") value (0) increment (0.001)
}

groupbox bounds(528, 362, 243, 122) identchannel("LFO1") text("LFO - A"){
button bounds(10, 22, 54, 29) channel("Lsw1") text("off", "on") value(0)
combobox bounds(10, 73, 54, 29) channel("LWF1") text("Sine", "Tri", "SqrBi","SqrUni", "Saw")
rslider bounds(60, 29, 126, 75) range(0, 20, 0.2, 1, 0.001) channel("Lrate1") valuetextbox(1)  text("Rate")
rslider bounds(130, 29, 126, 75) range(0, 1, 0.5, 1, 0.001) channel("Lamount1") valuetextbox(1)  text("Amount")

}
groupbox bounds(14, 362, 229, 124) identchannel("LFO2") text("LFO - Pitch"){
button bounds(9, 23, 53, 30) channel("Lsw2") text("off", "on") value(0)
combobox bounds(9, 75, 53, 30) channel("LWF2") text("Sine", "Tri", "SqrBi","SqrUni", "Saw")
rslider bounds(60, 30, 123, 77) range(0, 20, 0.2, 1, 0.001) channel("Lrate2") valuetextbox(1)  text("Rate")
rslider bounds(130, 30, 123, 77) range(0, 1, 0.5, 1, 0.001) channel("Lamount2") valuetextbox(1)  text("Amount")
}

groupbox bounds(271, 52, 220, 123) identchannel("FILTER") text("LPF"){
rslider bounds(107, 31, 118, 80) range(0, 1, 0.8, 1, 0.001) channel("RES")  identchannel("RES") valuetextbox(1) text("Resonance")
rslider bounds(5, 31, 118, 80) range(0, 20000, 20000, 1, 1) channel("CUTOFF") identchannel("CUTOFF")  valuetextbox(1) text("Cutoff")
button bounds(8, 23, 31, 20) text("off", "on") channel("Fsw3")
}

groupbox bounds(12, 218, 232, 116) identchannel("EG2") text("PitchEG") colour(41, 46, 46, 255){
vslider bounds(5, 21, 34, 92) range(0.001, 10, 0.001, 1, 0.001) channel("A2")  text("A") valuetextbox(1)
vslider bounds(41, 21, 34, 92) range(0.001, 10, 0.001, 1, 0.001) channel("D2")  text("D") valuetextbox(1)
vslider bounds(77, 21, 34, 92) range(0, 1, 0.8, 1, 0.01) channel("S2")  text("S") valuetextbox(1) 
vslider bounds(113, 21, 34, 92) range(0.001, 10, 0.001, 1, 0.001) channel("R2")  text("R") valuetextbox(1)
button bounds(155, 25, 39, 15) channel("SwEG2") text("Off", "On")  increment(0.001)

}
groupbox bounds(271, 218, 220, 115) identchannel("EG3") text("FEG") colour(26, 26, 26, 255){
vslider bounds(3, 19, 34, 85) range(0.001, 5, 0.001, 1, 0.001) channel("A3")  text("A") valuetextbox(1)
vslider bounds(42, 19, 38, 86) range(0.001, 5, 0.001, 1, 0.001) channel("D3") value(0.001) text("D") valuetextbox(1)
vslider bounds(81, 19, 38, 86) range(0, 1, 0.8, 1, 0.01) channel("S3")  text("S") valuetextbox(1) 
vslider bounds(116, 19, 45, 86) range(0.001, 5, 0.001, 1, 0.001) channel("R3")  text("R") valuetextbox(1)
button bounds(174, 24, 32, 19) channel("SwEG3") text("Off", "On") value (0) increment (0.001)
}

groupbox bounds(270, 362, 224, 124) identchannel("LFO3") text("LFO - Filter"){
button bounds(10, 23, 54, 30) channel("Lsw3") text("off", "on") value(0)
combobox bounds(10, 75, 54, 30) channel("LWF3") text("Sine", "Tri", "SqrBi","SqrUni", "Saw")
rslider bounds(60, 30, 126, 77) range(0, 20, 0.2, 1, 0.001) channel("Lrate3") valuetextbox(1)  text("Rate")
rslider bounds(125, 30, 126, 77) range(0, 1, 0.5, 1, 0.001) channel("Lamount3") valuetextbox(1)  text("Amount")
}
</Cabbage>
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1
;Andrei Valentino
;instrument will be triggered by keyboard widget
            instr 5
;;;;;;;;;;;;;;;;  Filtro  ;;;;;;;;;;;;;;;;;;

kRES     chnget   "RES"
kCUTOFF  chnget   "CUTOFF"
kFsw3    chnget   "Fsw3"

;;;;;;;;;;;;;;;;; Master ;;;;;;;;;;;;;;;;           

k2          chnget   "masterPan"
k1          chnget   "masterV"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;; Tuner - Afinadores ;;;;;;;;;;;;;

kFINE       chnget  "FINE"
kFINE       pow     2, kFINE/12

kCOARSE     chnget  "COARSE"
kCOARSE     pow     2, kCOARSE/12

kRANGE      chnget  "RANGE"
kRANGE      pow     2, kRANGE  
 
;;;;;;;;;;;;;;;;;;Panel AEG ;;;;;;;;;;;;;;;;;;;;;;;;;;;


kSwEG1      chnget "SwEG1"
iA1         chnget "A1"
iD1         chnget "D1"
iS1         chnget "S1"
iR1         chnget "R1"

;;;;;;;;;;;;;;;;;;PitchEG ;;;;;;;;;;;;;;;;;;;;;;;;;;;


kSwEG2      chnget "SwEG2"
iA2         chnget "A2"
iD2         chnget "D2"
iS2         chnget "S2"
iR2         chnget "R2"

;;;;;;;;;;;;;;;;;;;;;; Panel FilterEG ;;;;;;;;;;;;;;

kSwEG3      chnget "SwEG3"
iA3         chnget "A3"
iD3         chnget "D3"
iS3         chnget "S3"
iR3         chnget "R3"


;;;;;;;;;;;;;;;; LFO - A ;;;;;;;;;;;;;;;;;;


kLsw1       chnget   "Lsw1"
iLWF1       chnget   "LWF1"
kLrate1     chnget   "Lrate1"
kLamount1   chnget   "Lamount1"

kLFOA       lfo    kLamount1 , kLrate1 , iLWF1 - 1 ; -1 ..... +1

kLFOA  = 0 + ( 1 ) * ( kLFOA  - -1 ) / ( 2 ) 	; Interpolación lineal  0 ..... +1	

            if kLsw1 == 0 then
               kLFOA =  1
            endif
            
;;;;;;;;;;;;;;;; LFO - Pitch ;;;;;;;;;;;;;;;;;;

kLsw2       chnget   "Lsw2"
iLWF2       chnget   "LWF2"
kLrate2     chnget   "Lrate2"
kLamount2   chnget   "Lamount2"

kLFOP       lfo    kLamount2 , kLrate2 , iLWF2 - 1 ; -1 .... +1

kLFOP = 1 + ( 3 ) * ( kLFOP - -1 ) / ( 2 ) 	    ; Interpolación lineal 1 ...... +4	

            if kLsw2 == 0 then
               kLFOP =  1 
            endif
;;;;;;;;;;;;;;;; LFO - Filter ;;;;;;;;;;;;;;;;;;

kLsw3       chnget   "Lsw3"
iLWF3       chnget   "LWF3"
kLrate3     chnget   "Lrate3"
kLamount3   chnget   "Lamount3"

kLFOFilter       lfo    kLamount3 , kLrate3 , iLWF3 - 1 ; -1 .... +1

kLFOFilter =   0 + ( 1 ) * ( kLFOFilter - -1 ) / ( 2 ) ; Interpolación lineal 0 ...... +1	

            if kLsw3 == 0 then
               kLFOFilter =  1 
            endif               
              
;;;;;;;;;;;;;;;;; AEG ;;;;;;;;;;;;;;;;;;;;;;;;;;;


kAEG        madsr   iA1, iD1, iS1, iR1 
            if kSwEG1 == 0 then
               kAEG        madsr  .001, .001, .8, .001
            
            endif

;;;;;;;;;;;;;;;;; PEG ;;;;;;;;;;;;;;;;;;;;;;;;;;;


kPEG        madsr   iA2, iD2, iS2, iR2 
kPEG = 1 + ( 3 ) *  kPEG	

            if kSwEG2 == 0 then
               kPEG        madsr  .001, .001, .8, .001
            
            endif
;;;;;;;;;;;;;;;;; FilterEG ;;;;;;;;;;;;;;;;;;;;;;;;;;;
kFilterEG        madsr   iA3, iD3, iS3, iR3

            if kSwEG3 == 0 then
               kFilterEG        madsr  .001, .001, .8, .001
            
            endif            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                 
kWF         chnget   "OWF"             
a1          oscilikt   p5 * kAEG * kLFOA , p4 *kFINE *kCOARSE *kRANGE *kLFOP * kPEG  , kWF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;FilTro;;;;;;;;;;;;;;;


kRES     chnget   "RES"
kCUTOFF  chnget   "CUTOFF"
kFsw3    chnget   "Fsw3"

if    kFsw3   == 0 then 
      kCUTOFF = 20000
      kRES    = 0
      endif
      
aOut        moogvcf2   a1  , kCUTOFF * kFilterEG * kLFOFilter, kRES

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
            outs       aOut *k2 *k1 , aOut *(1 - k2) *k1 
            endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
f 1  0 16384  10  1 ; sine
f 2  0 16384  10  1 .5 .33 .25 .2; Sawtooth 5x
f 3  0 16384  10  1 0 .33 0 .2 0 .14 0 .11; square 5x 
f 4  0 16384  10  1   0 0 0 0 0 0 0 0 0 0 0    .2; Ep1_da_furia
f 5  0 16384   9  1   1  0   13   .2  0 ; Ep1_Gen9
f 6  0 16384   9  1  1  0  6.25 .2 0   17.4   .1   0 ;EP2_DaFuria
f 7  0 16384   9  1  1  0    2.7   0.5  0  6.75    0.2   0; vib_Dafuria
f 8  0 16384   9  1 1 0   1.42 0.8  0 1.53  0.4  0 1.77  0.2 0 1.94   0.1  0; Timpani_Dafuria
f 9  0 16384  9  1  1 0  2.02  0.5  0  2.35  1  0  3.35  0.6  0  4.27  0.5 0; TingShaw_sethares
f 10 0 16384   9  1  0.2  0   1.51  0.9  0  1.6  0.9  0  3.01   1  0  3.75  0.5  0  5.67  0.5  0; ChacoRock_Sethares
f 11 0 16384   9  0.92  0.51  0  1.19  0.37  0  1.71  0.65  0  2.74  0.33  0  3.76  0.68  0  4.07  0.34  0;BellTone_Sethares
f 12 0 16384   7 -1   16384    1; SawAsc
f 13 0 16384   7  1   16384   -1; SawDsc
f 14 0 16384   7 -1    8192    1   8192  -1; Tri_1
f 15 0 16384   7  0    4096    1   8192  -1  4096   0; Tri_2
f 16 0 16384   7  1    8192    1    1    -1  8191 -1; Square_Line
f 17 0 16384   7  1    4096    1  0  -1   12288  -1 ; Pulse_25
</CsScore>
</CsoundSynthesizer>
